package com.fp.persistence.parmas.soli;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMSOLICITUDAGENCIASUCURSAL*/
@Entity(name="TarmSolicitudAgenciaSucursal")
@Table(name="TARMSOLICITUDAGENCIASUCURSAL")
public class TarmSolicitudAgenciaSucursal extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmSolicitudAgenciaSucursal
*/
@EmbeddedId
private TarmSolicitudAgenciaSucursalKey pk;
@Column(name="ESTADO", nullable=true)

/**
* Estado de la agencia en el proceso de la solicitud
*/
private String estado;

@Column(name="ESTADOCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo
*/
private String estadocodigo;

/**Contructor por defecto*/
public TarmSolicitudAgenciaSucursal(){
}
/**Contructor de TarmSolicitudAgenciaSucursal
@param pPk Clave Primaria del entity
*/
public TarmSolicitudAgenciaSucursal(TarmSolicitudAgenciaSucursalKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmSolicitudAgenciaSucursal
*/
public static TarmSolicitudAgenciaSucursal find(EntityManager pEntityManager,TarmSolicitudAgenciaSucursalKey pKey) throws Exception{
    TarmSolicitudAgenciaSucursal obj = pEntityManager.find(TarmSolicitudAgenciaSucursal.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmSolicitudAgenciaSucursal
@return El objeto que referencia a la Clave primaria de TarmSolicitudAgenciaSucursal
*/
public TarmSolicitudAgenciaSucursalKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmSolicitudAgenciaSucursal
@param pPk El objeto que referencia a la nueva Clave primaria de TarmSolicitudAgenciaSucursal
*/
public void setPk(TarmSolicitudAgenciaSucursalKey pPk){
  pk=pPk;
}
/**Obtiene el valor de estado
@return valor de estado*/
public String getEstado(){
  return estado;
}
/**Fija el valor de estado
@param pEstado nuevo Valor de estado*/
public void setEstado(String pEstado){
  estado=pEstado;
}

/**Obtiene el valor de estadocodigo
@return valor de estadocodigo*/
public String getEstadocodigo(){
  return estadocodigo;
}
/**Fija el valor de estadocodigo
@param pEstadocodigo nuevo Valor de estadocodigo*/
public void setEstadocodigo(String pEstadocodigo){
  estadocodigo=pEstadocodigo;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmSolicitudAgenciaSucursal))return false;
    TarmSolicitudAgenciaSucursal that = (TarmSolicitudAgenciaSucursal) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmSolicitudAgenciaSucursal
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmSolicitudAgenciaSucursal
*/
public Object createInstance(){
 TarmSolicitudAgenciaSucursal instance=new TarmSolicitudAgenciaSucursal();	
 instance.setPk(new TarmSolicitudAgenciaSucursalKey());
 return instance;
}
/**Clona la entidad TarmSolicitudAgenciaSucursal
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmSolicitudAgenciaSucursal p=(TarmSolicitudAgenciaSucursal)this.clone();
  p.setPk((TarmSolicitudAgenciaSucursalKey)this.pk.cloneMe());
  return p;
}
}
